#!/sbin/sh
# 
# permfixer.sh - fixes permissions on Android data directories after upgrade
# shade@chemlab.org
#
# thanks to: http://blog.elsdoerfer.name/2009/05/25/android-fix-package-uid-mismatches/
#
# Modified by -FuFu- to use on Milestone
# v1.0 - work with protected apps

CODEPATH="";
UID="";
PACKAGE="";
IS_PROTECTED="0";

mount /system > /dev/null 2>&1
mount /data > /dev/null 2>&1
mount /sdcard > /dev/null 2>&1

mount -t ext2 /dev/block/mmcblk0p2 /data/app2sd > /dev/null 2>&1
umount /data/app2sd > /dev/null 2>&1
mount -t ext2 /dev/block/mmcblk0p2 /data/app2sd > /dev/null 2>&1
mount -o bind /data/app2sd/app /data/app > /dev/null 2>&1
mount -o bind /data/app2sd/app-private /data/app-private > /dev/null 2>&1


cat /data/system/packages.xml | grep "^<package" | busybox grep userId | while read line;
do
	for i in `echo $line | tr " " "\n"`;
	do
		if [ $i = "<package" ];
		then
			CODEPATH="";
			PACKAGE="";
			UID="";
		elif ( echo $i | busybox grep "^codePath" > /dev/null );
		then
			CODEPATH=`echo $i | busybox cut -d \" -f 2`;
		elif ( echo $i | busybox grep "^name" > /dev/null );
		then
			PACKAGE=`echo $i | busybox cut -d \" -f 2`;
		elif ( echo $i | busybox grep "^userId" > /dev/null );
		then
			UID=`echo $i | busybox cut -d \" -f 2`;
		fi;
	
		APPDIR=`echo $CODEPATH | busybox cut -d / -f 3`;
		if [ "$APPDIR" = "app-private" ];
		then
			IS_PROTECTED=1;
		else
			IS_PROTECTED=0;
		fi

	done;

	echo "Fixing permissions for: $PACKAGE";

	if [ $IS_PROTECTED = "1" ];
	then
		busybox chown 1000:$UID $CODEPATH;
	else
		busybox chown $UID:$UID $CODEPATH;
	fi;

	busybox chown $UID:$UID /data/data/$PACKAGE;

	for dir in databases shared_prefs;
	do
		if [ -d /data/data/$PACKAGE/$dir ];
		then
			busybox chown -R $UID:$UID /data/data/$PACKAGE/$dir;
		fi;
	done	
done;
echo ""
echo "Permissons gefixt"
sleep 1
exit 0